/* Tabela OPERGRUPOP: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela OPERGRUPOP */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela OPERGRUPOP, utilizando
a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_OPERGRUPOP' AND
                 TYPE   = 'TR' 		                AND
	              U.UID  = O.UID                   AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_OPERGRUPOP
GO


CREATE TRIGGER LOG_GER_OPERGRUPOP
ON OPERGRUPOP
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO          VARCHAR(40);
   DECLARE  @V_TIPO             VARCHAR(1);
   DECLARE  @V_ITPESQ           VARCHAR(40);
   DECLARE  @V_DESC             VARCHAR(300);
   DECLARE  @V_DTOPER           DATETIME;
/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO       VARCHAR(1);
   DECLARE  @V_OLD_CDGRUPOPER   VARCHAR(2)
   DECLARE  @V_OLD_IDMENUPRINOP VARCHAR(1)
   DECLARE  @V_OLD_CDOPERADOR   VARCHAR(12)
   DECLARE  @V_NEW_CDGRUPOPER   VARCHAR(2)
   DECLARE  @V_NEW_IDMENUPRINOP VARCHAR(1)
   DECLARE  @V_NEW_CDOPERADOR   VARCHAR(12)
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
         CDGRUPOPER,
         IDMENUPRINOP,
         CDOPERADOR,
         NULL,
         NULL,
         NULL
   FROM
      DELETED
   WHERE
     CDGRUPOPER+ CDOPERADOR NOT IN (SELECT CDGRUPOPER+ CDOPERADOR FROM INSERTED)
   UNION ALL

   SELECT
     'U' IDCOMANDO,
         DELETED.CDGRUPOPER,
         DELETED.IDMENUPRINOP,
         DELETED.CDOPERADOR,
         INSERTED.CDGRUPOPER,
         INSERTED.IDMENUPRINOP,
         INSERTED.CDOPERADOR
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDGRUPOPER  = DELETED.CDGRUPOPER   AND
      INSERTED.CDOPERADOR  = DELETED.CDOPERADOR
   UNION ALL

   SELECT
     'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         CDGRUPOPER,
         IDMENUPRINOP,
         CDOPERADOR
   FROM
      INSERTED
   WHERE
      CDGRUPOPER+ CDOPERADOR NOT IN (SELECT CDGRUPOPER+ CDOPERADOR FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDGRUPOPER,
                                 @V_OLD_IDMENUPRINOP,
                                 @V_OLD_CDOPERADOR,
                                 @V_NEW_CDGRUPOPER,
                                 @V_NEW_IDMENUPRINOP,
                                 @V_NEW_CDOPERADOR;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_OLD_CDGRUPOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cod=' + @V_OLD_CDGRUPOPER;
         END;
         IF @V_OLD_IDMENUPRINOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Menu=' + @V_OLD_IDMENUPRINOP;
         END;
         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_OLD_CDGRUPOPER + @V_OLD_CDOPERADOR;
      END
      ELSE
         IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
            IF (@V_OLD_CDGRUPOPER   <> @V_NEW_CDGRUPOPER)   OR
               (@V_OLD_IDMENUPRINOP <> @V_NEW_IDMENUPRINOP) BEGIN

               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDGRUPOPER + @V_OLD_CDOPERADOR;
            END;
         END
      ELSE BEGIN
         SET @V_TIPO         = '1';
         SET @V_ITPESQ       = @V_NEW_CDGRUPOPER + @V_NEW_CDOPERADOR;
      END;
      IF @V_NEW_CDGRUPOPER IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + 'Cod=' + @V_NEW_CDGRUPOPER;
      END;

      IF @V_NEW_CDOPERADOR IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Operador=' + @V_NEW_CDOPERADOR;
      END;

      IF @V_NEW_IDMENUPRINOP IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Menu=' + @V_NEW_IDMENUPRINOP;
      END;
      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('OPERGRUPOP',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDGRUPOPER,
                                    @V_OLD_IDMENUPRINOP,
                                    @V_OLD_CDOPERADOR,
                                    @V_NEW_CDGRUPOPER,
                                    @V_NEW_IDMENUPRINOP,
                                    @V_NEW_CDOPERADOR;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_OPERGRUPOP','4.11.105';
GO

